package com.unipi.talepis.softeng2023_10;

import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;

import android.content.DialogInterface;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.View;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonArrayRequest;
import com.android.volley.toolbox.Volley;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class MainActivity2 extends AppCompatActivity {
    RequestQueue requestQueue;
    MyTts myTts;
    SQLiteDatabase sqLiteDatabase;
    String createTableSQL = "CREATE TABLE if not exists Joke (\n" +
            "    Setup    TEXT    NOT NULL,\n" +
            "    Punchline TEXT    NOT NULL,\n" +
            "    Joke_ID INTEGER PRIMARY KEY \n" +
            ");";
    String setup, punchline;
    int jokeID;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main2);
        requestQueue = Volley.newRequestQueue(this);
        myTts = new MyTts(this);
        sqLiteDatabase = openOrCreateDatabase("JokesDB.db",MODE_PRIVATE,null);
        sqLiteDatabase.execSQL(createTableSQL);
    }
    public void joke(View view){
        String url = "https://official-joke-api.appspot.com/jokes/programming/random";
        JsonArrayRequest arrayRequest = new JsonArrayRequest(url, new Response.Listener<JSONArray>() {
            @Override
            public void onResponse(JSONArray response) {
                try {
                    JSONObject jsonObject = response.getJSONObject(0);
                    setup = jsonObject.getString("setup");
                    punchline = jsonObject.getString("punchline");
                    jokeID = jsonObject.getInt("id");
                    myTts.speak(setup);
                    showMessageWithOk("Question",setup);
                } catch (JSONException e) {
                    throw new RuntimeException(e);
                }
            }
        }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {

            }
        });
        requestQueue.add(arrayRequest);
    }
    public void save(View view){
        String insertSQL = "Insert or ignore into Joke(Setup,Punchline,Joke_ID) " +
                "values(?,?,?)";
        String[] parameters = new String[3];
        parameters[0] = setup;
        parameters[1] = punchline;
        parameters[2] = String.valueOf(jokeID);
        sqLiteDatabase.execSQL(insertSQL,parameters);
        showMessage("Info","Joke saved in favorites!");
    }
    public void random(View view){
        String selectSQL = "SELECT * FROM Joke ORDER BY RANDOM() LIMIT 1";
        Cursor cursor = sqLiteDatabase.rawQuery(selectSQL,null);
        if (cursor.moveToNext()){
            setup = cursor.getString(0);
            punchline = cursor.getString(1);
            jokeID = cursor.getInt(2);
        }
        cursor.close();
        myTts.speak(setup);
        showMessageWithOk("Question",setup);
    }
    private void showMessage(String title, String message){
        new AlertDialog.Builder(this)
                .setTitle(title)
                .setMessage(message)
                .setCancelable(true)
                .show();
    }
    private void showMessageWithOk(String title, String message){
        new AlertDialog.Builder(this)
                .setTitle(title)
                .setMessage(message)
                .setCancelable(true)
                .setPositiveButton("Ok", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        myTts.speak(punchline);
                        showMessage("Joke",punchline);
                    }
                })
                .show();
    }
}